/*
 * Liste:
 * - identificate dal loro primo elemento
 * - singolarmente concatenate
 * - ordinate (in modo non decrescente)
 */

class List{
	int value;
	List next;
}

public class MainClass {

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		testLista();
	}

	static void testLista() {
		List l = null;
		stampaLista(l);
		l=insert (l, 10);
		stampaLista(l);
		l=insert (l, 20);
		stampaLista(l);
		l=insert (l, 5);
		stampaLista(l);
		l=insert (l, 15);
		stampaLista(l);
		System.out.println (length(l));
		System.out.println (lengthRic(l));
	}
	
	/*
	 * Metodo che inserisce un intero nella lista l
	 * ATTENZIONE: poich la lista  identificata dal primo elemento,
	 *              necesario restituire la lista dato che il primo elemento pu cambiare
	 */
	static List insert (List l, int value) {
		List nuovo = new List();
		nuovo.value=value;
		
		List i = l;
		List prev = null;
		while (i!=null && i.value<value) {
			prev = i;
			i = i.next;
		}
		if (prev==null) {//inserisco in testa
			nuovo.next=l;
			return nuovo;
			
		} else {
			nuovo.next=prev.next;
			prev.next=nuovo;
			return l;
		}
		
		
	}
	
	static void stampaLista(List l) {
		String ris = "[";

		for (List i = l; i != null; i = i.next) {
			ris += i.value;
			if (i.next != null) {
				ris += ", ";
			}
		}

		ris += "]";
		System.out.println(ris);
	}
	
	/*
	 * metodo ITERATIVO che calcola la lunghezza di una lista l
	 */
	static int length (List l) {
		int conto=0;
		for (List i = l; i != null; i = i.next) {
			conto++;
		}
		return conto;
	}
	
	/*
	 * metodo RICORSIVO che calcola la lunghezza di una lista l
	 */
	static int lengthRic (List l) {
		if (l==null) return 0;  //caso base
		return 1+lengthRic(l.next);
	}
	
	/*
	 * metodo ITERATIVO che restituisce true se e solo se il valore cercato  presente in lista
	 */
	static boolean search (List l, int value) {
		for (List i=l; i!=null && i.value<=value; i=i.next) {
			if (i.value==value) return true;
		}
		return false;
	}
	
	/*
	 * metodo RICORSIVO che restituisce true se e solo se il valore cercato  presente in lista
	 */
	static boolean searchRic (List l, int value) {
		if (l==null || l.value>value) return false;  //caso BASE negativo
		if (l.value==value) return true; //caso BASE positivo
		return searchRic (l.next, value); //caso RICORSIVO
	}
	
}
