class Elem {
	int value;
	Elem next;
}

class Stack {
	Elem top;
	int size;
}

class Queue {
	Elem first;  //punto di uscita
	Elem last;   //punto di entrata
	int size;
}

public class MainClass {

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		//testCoda();
		testInvertiCoda();
	}

	static void testInvertiCoda() {
		/*
		 * 1) creare una coda vuota
		 * 2) aggiungere tre interi alla coda
		 * 3) stampare la coda
		 * 4) invertirla col metodo invertiCoda
		 * 5) ristamparla
		 */
		//1
		Queue q = new Queue();
		//2
		enqueue (q, 1);
		enqueue (q, 2);
		enqueue (q, 3);
		stampaCoda(q);
		invertiCoda(q);
		stampaCoda(q);
	}
	
	/*  1) creare una pila vuota s
	 *  2) estrarre tutti gli elementi di q e aggiungerli ad s 
	 *  3) estrarre tutti gli elementi di s e aggiungerli ad q
	 */
	static void invertiCoda (Queue q) {
		if (q==null) return;
		//1
		Stack s = new Stack();
		//2
		while (q.size>0) {
			push (s, dequeue(q));
		}
		//3
		while (s.size>0) {
			enqueue (q, pop(s));
		}
		
	}
	
	static void testCoda() {
		Queue q = new Queue();
		stampaCoda(q);
		enqueue(q,5);
		stampaCoda(q);
		enqueue(q,10);
		stampaCoda(q);
		enqueue(q,3);
		stampaCoda(q);
		System.out.println(dequeue(q));
		stampaCoda(q);
		enqueue(q,20);
		stampaCoda(q);
		System.out.println(dequeue(q));
		stampaCoda(q);
		System.out.println(dequeue(q));
		stampaCoda(q);
		System.out.println(dequeue(q));
		stampaCoda(q);
		System.out.println(dequeue(q));
		stampaCoda(q);
		System.out.println(dequeue(q));
		stampaCoda(q);
	}
	
	static void testPila() {
		Stack s = new Stack();
		stampaPila(s);
		push(s, 1);
		stampaPila(s);
		push(s, 2);
		stampaPila(s);
		push(s, 5);
		stampaPila(s);
		System.out.println(pop(s));
		stampaPila(s);
		System.out.println(pop(s));
		stampaPila(s);
		push(s, 7);
		stampaPila(s);
		System.out.println(pop(s));
		stampaPila(s);
		System.out.println(pop(s));
		stampaPila(s);
		System.out.println(pop(s));
		stampaPila(s);
		System.out.println(pop(s));
		stampaPila(s);
	}
	static void push(Stack s, int i) {
		if (s == null) {
			System.out.println("ERROR: Stack does not exist");
			return;
		}
		Elem nuovo = new Elem();
		nuovo.value = i;
		nuovo.next = s.top;
		s.top = nuovo;
		s.size++;
	}

	static int pop(Stack s) {
		if (s == null) {
			System.out.println("ERROR: Stack does not exist");
			return 0;
		}
		if (s.size == 0) {
			System.out.println("ERROR: Stack is empty");
			return 0;
		}
		int ris = (s.top).value;
		s.top = (s.top).next;
		s.size--;
		return ris;
	}

	static void stampaPila(Stack s) {
		if (s == null)
			return;
		String ris = "[";

		/*
		 * Elem e = s.top; while (e!=null) { ris += e.value; if (e.next!=null) { ris +=
		 * ", "; } e=e.next; }
		 */
		for (Elem e = s.top; e != null; e = e.next) {
			ris += e.value;
			if (e.next != null) {
				ris += ", ";
			}
		}

		ris += "]";
		System.out.println(ris);
	}
	
	static void stampaCoda(Queue q) {
		if (q == null)
			return;
		String ris = "[";

		for (Elem e = q.first; e != null; e = e.next) {
			ris += e.value;
			if (e.next != null) {
				ris += ", ";
			}
		}

		ris += "]";
		System.out.println(ris);
	}
	
	static void enqueue (Queue q, int i) {
		if (q == null) {
			System.out.println("ERROR: Queue does not exist");
			return;
		}
		Elem nuovo=new Elem();
		nuovo.value=i;
		//aggiungo nuovo come last
		if (q.last!=null) { //caso in cui c'era gi un elemento in coda
			q.last.next=nuovo;
		} else { //sto inserendo il primo elemento in coda
			q.first=nuovo;
		}
		q.last=nuovo;
		q.size++;
	}
	
	static int dequeue (Queue q) {
		if (q == null) {
			System.out.println("ERROR: Queue does not exist");
			return 0;
		}
		if (q.size == 0) {
			System.out.println("ERROR: Queue is empty");
			return 0;
		}
		int ris = (q.first).value;
		q.first = (q.first).next;
		if (q.first==null) { //ho estratto l'ultimo elemento
			q.last=null;
		}
		q.size--;
		return ris;
	}

}
